//------------------------------------------------------------------------
//Material.cpp	
//------------------------------------------------------------------------
#include "stdafx.h"
#include "VixarLibrary.h"

//------------------------------------------------------------------------
//CMaterialNX
//------------------------------------------------------------------------
CMaterial::CMaterial()
{
	m_name = "NoMaterial";
	m_r = 0.8f;
	m_g = 0.8f;
	m_b = 0.8f;
	m_a = 1.0f;
	m_diffuse = 1.0f;
	m_ambient = 1.0f;
	m_emissive = 0.0f;
	m_specular = 0.0f;
	m_power = 0.2f;
	m_texture_name.clear();
	m_alpha_name.clear();
	m_bump_name.clear();
	m_texture = NULL;
	SetMaterial();
}

//------------------------------------------------------------------------
//fXgN^
//------------------------------------------------------------------------
CMaterial::~CMaterial()
{
}

//------------------------------------------------------------------------
//Zq̃I[o[[h	
//------------------------------------------------------------------------
CMaterial& CMaterial::operator=(const CMaterial& pt)
{
	m_name = pt.m_name;
	m_r = pt.m_r;
	m_g = pt.m_g;
	m_b = pt.m_b;
	m_a = pt.m_a;
	m_diffuse = pt.m_diffuse;
	m_ambient = pt.m_ambient;
	m_emissive = pt.m_emissive;
	m_specular = pt.m_specular;
	m_power = pt.m_power;
	m_material = pt.m_material;
	m_texture_name = pt.m_texture_name;
	m_alpha_name = pt.m_alpha_name;
	m_bump_name = pt.m_bump_name;
	m_texture = pt.m_texture;

	return *this;
}

//------------------------------------------------------------------------
//CMaterial
//------------------------------------------------------------------------
CMaterial::CMaterial (const CMaterial& pt)
{
	*this = pt;
}

//------------------------------------------------------------------------
//}eA̐ݒ
//------------------------------------------------------------------------
void CMaterial::SetMaterial()
{
	// fBt[Y˂\ RGBA ݒ肷B
	m_material.Diffuse.r = m_r * m_diffuse;
	m_material.Diffuse.g = m_g * m_diffuse;
	m_material.Diffuse.b = m_b * m_diffuse;
	m_material.Diffuse.a = m_a;
	// ArGg˂\ RGBA ݒ肷B
	m_material.Ambient.r = m_r * m_ambient;
	m_material.Ambient.g = m_g * m_ambient;
	m_material.Ambient.b = m_b * m_ambient;
	m_material.Ambient.a = m_a;
	// XyL nCCg̐FƃV[vݒ肷B
	m_material.Specular.r = m_specular;
	m_material.Specular.g = m_specular;
	m_material.Specular.b = m_specular;
	m_material.Specular.a = m_a;
	m_material.Power = m_power;
	// RGBA G~bVFݒ肷B
	m_material.Emissive.r = m_r * m_emissive;
	m_material.Emissive.g = m_g * m_emissive;
	m_material.Emissive.b = m_b * m_emissive;
	m_material.Emissive.a = m_a;
}

//------------------------------------------------------------------------
//eNX`Zbg
//------------------------------------------------------------------------
void CMaterial::LoadTexture(LPDIRECT3DDEVICE9 dev)
{
	if ( !m_texture_name.empty() )
	{
		std::ostringstream stream;
		stream << GetDirectory() << "TEXTURE\\" << m_texture_name;
		// eNX`ǂݍ
		D3DXCreateTextureFromFileEx(dev,stream.str().c_str(),0,0,0,0,D3DFMT_A8R8G8B8,
			D3DPOOL_MANAGED,D3DX_FILTER_LINEAR,D3DX_FILTER_LINEAR,0,NULL,NULL,&m_texture);
	}
}

//------------------------------------------------------------------------
//}eAZbg
//------------------------------------------------------------------------
void CMaterial::SetName(std::string name)
{
	m_name = name;
}

//------------------------------------------------------------------------
//}eA擾
//------------------------------------------------------------------------
std::string CMaterial::GetName()
{
	return m_name;
}

//------------------------------------------------------------------------
//ԁE΁EEAt@Zbg
//------------------------------------------------------------------------
void CMaterial::SetRGBA(float r,float g,float b,float a)
{
	m_r = r;
	m_g = g;
	m_b = b;
	m_a = a; 
}

//------------------------------------------------------------------------
//Ԏ擾
//------------------------------------------------------------------------
float CMaterial::GetR() const
{
	return m_r;
}

//------------------------------------------------------------------------
//Ύ擾
//------------------------------------------------------------------------
float CMaterial::GetG() const
{
	return m_g;
}

//------------------------------------------------------------------------
//擾
//------------------------------------------------------------------------
float CMaterial::GetB() const
{
	return m_b;
}

//------------------------------------------------------------------------
//At@擾
//------------------------------------------------------------------------
float CMaterial::GetA() const
{
	return m_a;
}

//------------------------------------------------------------------------
//ShaderZbg
//------------------------------------------------------------------------
void CMaterial::SetShader(int shader)
{
	m_shader = shader;
}

//------------------------------------------------------------------------
//Shader擾
//------------------------------------------------------------------------
int CMaterial::GetShader()
{
	return m_shader;
}

//------------------------------------------------------------------------
//gUZbg
//------------------------------------------------------------------------
void CMaterial::SetDiffuse(float diffuse)
{
	m_diffuse = diffuse;
}

//------------------------------------------------------------------------
//gU擾
//------------------------------------------------------------------------
float CMaterial::GetDiffuse()
{
	return m_diffuse;
}

//------------------------------------------------------------------------
//͌Zbg
//------------------------------------------------------------------------
void CMaterial::SetAmbient(float ambient)
{
	m_ambient = ambient;
}

//------------------------------------------------------------------------
//͌擾
//------------------------------------------------------------------------
float CMaterial::GetAmbient()
{
	return m_ambient;
}

//------------------------------------------------------------------------
//ȏƖZbg
//------------------------------------------------------------------------
void CMaterial::SetEmissive(float emissive)
{
	m_emissive = emissive;
}

//------------------------------------------------------------------------
//ȏƖ擾
//------------------------------------------------------------------------
float CMaterial::GetEmissive()
{
	return m_emissive;
}

//------------------------------------------------------------------------
//ˌZbg
//------------------------------------------------------------------------
void CMaterial::SetSpecular(float specular)
{
	m_specular = specular;
}

//------------------------------------------------------------------------
//ˌ擾
//------------------------------------------------------------------------
float CMaterial::GetSpecular()
{
	return m_specular;
}

//------------------------------------------------------------------------
//˂̋Zbg
//------------------------------------------------------------------------
void CMaterial::SetPower(float power)
{
	m_power = power;
}

//------------------------------------------------------------------------
//˂̋擾
//------------------------------------------------------------------------
float CMaterial::GetPower()
{
	return m_power;
}

//------------------------------------------------------------------------
//eNX`Zbg
//------------------------------------------------------------------------
void CMaterial::SetTextureName(std::string texture_name)
{
	m_texture_name = texture_name;
}

//------------------------------------------------------------------------
//eNX`擾
//------------------------------------------------------------------------
std::string CMaterial::GetTextureName()
{
	return m_texture_name;
}

//------------------------------------------------------------------------
//At@eNX`Zbg
//------------------------------------------------------------------------
void CMaterial::SetAlphaName(std::string alpha_name)
{
	m_alpha_name = alpha_name;
}

//------------------------------------------------------------------------
//At@eNX`擾
//------------------------------------------------------------------------
std::string CMaterial::GetAlphaName()
{
	return m_alpha_name;
}

//------------------------------------------------------------------------
//oveNX`Zbg
//------------------------------------------------------------------------
void CMaterial::SetBumpName(std::string bump_name)
{
	m_bump_name = bump_name;
}

//------------------------------------------------------------------------
//oveNX`擾
//------------------------------------------------------------------------
std::string CMaterial::GetBumpName()
{
	return m_bump_name;
}

//------------------------------------------------------------------------
//}eAIuWFNg擾
//------------------------------------------------------------------------
D3DMATERIAL9* CMaterial::GetMaterial()
{
	return &m_material;
}

//------------------------------------------------------------------------
//eNX`IuWFNg擾
//------------------------------------------------------------------------
LPDIRECT3DTEXTURE9 CMaterial::GetTexture()
{
	return m_texture;
}

//------------------------------------------------------------------------
//eNX`̉
//------------------------------------------------------------------------
void CMaterial::ReleaseTexture()
{
	SAFE_RELEASE(m_texture);
}
