//------------------------------------------------------------------------
//Vertex.cpp	
//------------------------------------------------------------------------
#include "stdafx.h"
#include "VixarLibrary.h"

//------------------------------------------------------------------------
//RXgN^
//------------------------------------------------------------------------
CVertex::CVertex()
{
	m_pos = D3DXVECTOR3();
}

//------------------------------------------------------------------------
//fXgN^
//------------------------------------------------------------------------
CVertex::CVertex(float x, float y, float z)
{
	m_pos = D3DXVECTOR3(x,y,z);
}

//------------------------------------------------------------------------
//ʒuZbg
//------------------------------------------------------------------------
void CVertex::SetPos(D3DXVECTOR3 v)
{
	m_pos = v;
}

//------------------------------------------------------------------------
//ʒu擾
//------------------------------------------------------------------------
D3DXVECTOR3 CVertex::GetPos() const
{
	return m_pos;
}

//------------------------------------------------------------------------
//@Zbg
//------------------------------------------------------------------------
void CVertex::SetNormal(D3DXVECTOR3 v)
{
	m_normal = v;
}

//------------------------------------------------------------------------
//@擾
//------------------------------------------------------------------------
D3DXVECTOR3 CVertex::GetNormal()
{
	return m_normal;
}

//------------------------------------------------------------------------
//_Lʂzɒǉ
//------------------------------------------------------------------------
void CVertex::PushBackHaveFaces(int f)
{
	m_have_faces.push_back(f);
}

//------------------------------------------------------------------------
//_Lʂz̃TCY擾
//------------------------------------------------------------------------
int CVertex::GetHaveFacesSize()
{
	return (int)m_have_faces.size();
}

//------------------------------------------------------------------------
//_Lʂz̎擾
//------------------------------------------------------------------------
int CVertex::GetHaveFaces(int f)
{
	return m_have_faces[f];
}

//------------------------------------------------------------------------
//@̐K
//------------------------------------------------------------------------
void CVertex::Normalize()
{
	float x = m_normal.x;
	float y = m_normal.y;
	float z = m_normal.z;
	float length = sqrt(x*x+y*y+z*z);
	if ( length == 0 )
	{
		m_normal = D3DXVECTOR3(0,1,0);
	}
	else
	{
		m_normal /= length;
	}
}

//------------------------------------------------------------------------
//@Z
//------------------------------------------------------------------------
void CVertex::AddNormal(D3DXVECTOR3 v)
{
	m_normal += v;
}

//------------------------------------------------------------------------
//Zq̃I[o[[h
//------------------------------------------------------------------------
CVertex& CVertex::operator=(const CVertex& pt)
{
	m_pos = pt.m_pos;
	m_normal = pt.m_normal;
	m_have_faces = pt.m_have_faces;
	return *this;
}

//------------------------------------------------------------------------
//CVertex
//------------------------------------------------------------------------
CVertex::CVertex(const CVertex& pt)
{
	*this = pt;
}
